Index: Makefile
===================================================================
--- Makefile	(revision adde560017f6470fb7d5102af8fda3354682d4f4)
+++ Makefile	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -404,4 +404,5 @@
 	modules/ParticlePropagator.h \
 	modules/Efficiency.h \
+	modules/TrackEfficiency.h \
 	modules/IdentificationMap.h \
 	modules/EnergySmearing.h \
@@ -522,4 +523,7 @@
 	classes/DelphesStream.h \
 	external/ExRootAnalysis/ExRootTreeBranch.h
+tmp/classes/DelphesLongFormula.$(ObjSuf): \
+	classes/DelphesLongFormula.$(SrcSuf) \
+	classes/DelphesLongFormula.h
 tmp/classes/DelphesModule.$(ObjSuf): \
 	classes/DelphesModule.$(SrcSuf) \
@@ -984,4 +988,13 @@
 	external/ExRootAnalysis/ExRootFilter.h \
 	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/TrackEfficiency.$(ObjSuf): \
+	modules/TrackEfficiency.$(SrcSuf) \
+	modules/TrackEfficiency.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesLongFormula.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootFilter.h \
+	external/ExRootAnalysis/ExRootClassifier.h
 tmp/modules/TrackPileUpSubtractor.$(ObjSuf): \
 	modules/TrackPileUpSubtractor.$(SrcSuf) \
@@ -1067,4 +1080,5 @@
 	tmp/classes/DelphesHepMCReader.$(ObjSuf) \
 	tmp/classes/DelphesLHEFReader.$(ObjSuf) \
+	tmp/classes/DelphesLongFormula.$(ObjSuf) \
 	tmp/classes/DelphesModule.$(ObjSuf) \
 	tmp/classes/DelphesPileUpReader.$(ObjSuf) \
@@ -1148,4 +1162,5 @@
 	tmp/modules/TrackCountingBTagging.$(ObjSuf) \
 	tmp/modules/TrackCountingTauTagging.$(ObjSuf) \
+	tmp/modules/TrackEfficiency.$(ObjSuf) \
 	tmp/modules/TrackPileUpSubtractor.$(ObjSuf) \
 	tmp/modules/TrackSmearing.$(ObjSuf) \
@@ -1779,4 +1794,8 @@
 	tmp/external/tcl/tclVar.$(ObjSuf)
 
+modules/TrackEfficiency.h: \
+	classes/DelphesModule.h
+	@touch $@
+
 modules/DenseTrackFilter.h: \
 	classes/DelphesModule.h
Index: cards/delphes_card_llptest.tcl
===================================================================
--- cards/delphes_card_llptest.tcl	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
+++ cards/delphes_card_llptest.tcl	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -0,0 +1,89 @@
+set MaxEvents 1
+
+#######################################
+# Order of execution of various modules
+#######################################
+
+set ExecutionPath {
+  ParticlePropagator
+
+  ElectronTrackingEfficiency
+  ElectronMomentumSmearing
+  TreeWriter
+}
+
+#################################
+# Propagate particles in cylinder
+#################################
+
+module ParticlePropagator ParticlePropagator {
+  set InputArray Delphes/stableParticles
+
+  set OutputArray stableParticles
+  set ChargedHadronOutputArray chargedHadrons
+  set ElectronOutputArray electrons
+  set MuonOutputArray muons
+
+  # radius of the magnetic field coverage, in m
+  set Radius 1.29
+  # half-length of the magnetic field coverage, in m
+  set HalfLength 3.00
+
+  # magnetic field
+  set Bz 3.8
+}
+
+
+##############################
+# Electron tracking efficiency
+##############################
+
+module TrackEfficiency ElectronTrackingEfficiency {
+  set InputArray ParticlePropagator/electrons
+  set OutputArray electrons
+
+
+  # tracking efficiency formula (efficiency formula as a function of  pt, eta,  phi,  energy, d0 (mm), dz (mm), ctgTheta)
+  set EfficiencyFormula {
+                          (d0 < 1e-3) *                                      (pt <= 0.1)   * (0.00) +
+                          (d0 < 1e-3) *                (abs(eta) <= 1.5) * (pt > 0.1   && pt <= 1.0)      * (0.73) +
+                          (d0 < 1e-3) *                (abs(eta) <= 1.5) * (pt > 1.0   && pt <= 1.0e2)    * (0.95) +
+                          (d0 < 1e-3) *                 (abs(eta) <= 1.5) * (pt > 1.0e2)                  * (0.99) +
+                          (d0 < 1e-3) * (abs(eta) > 1.5 && abs(eta) <= 2.5) * (pt > 0.1   && pt <= 1.0)   * (0.50) +
+                          (d0 < 1e-3) * (abs(eta) > 1.5 && abs(eta) <= 2.5) * (pt > 1.0   && pt <= 1.0e2) * (0.83) +
+                          (d0 < 1e-3) * (abs(eta) > 1.5 && abs(eta) <= 2.5) * (pt > 1.0e2)                * (0.90) +
+                          (d0 < 1e-3) * (abs(eta) > 2.5)                                                  * (0.00) +
+                          (d0 > 1e-3) *                                                                   * (0.00)
+                         }
+}
+
+###################################
+# Momentum resolution for electrons
+###################################
+
+module MomentumSmearing ElectronMomentumSmearing {
+  set InputArray ElectronTrackingEfficiency/electrons
+  set OutputArray electrons
+
+  # set ResolutionFormula {resolution formula as a function of eta and energy}
+
+  # resolution formula for electrons
+  # based on arXiv:1502.02701
+  set ResolutionFormula {                  (abs(eta) <= 0.5) * (pt > 0.1) * sqrt(0.03^2 + pt^2*1.3e-3^2) +
+                         (abs(eta) > 0.5 && abs(eta) <= 1.5) * (pt > 0.1) * sqrt(0.05^2 + pt^2*1.7e-3^2) +
+                         (abs(eta) > 1.5 && abs(eta) <= 2.5) * (pt > 0.1) * sqrt(0.15^2 + pt^2*3.1e-3^2)}
+}
+
+##################
+# ROOT tree writer
+##################
+
+# tracks, towers and eflow objects are not stored by default in the output.
+# if needed (for jet constituent or other studies), uncomment the relevant
+# "add Branch ..." lines.
+
+module TreeWriter TreeWriter {
+# add Branch InputArray BranchName BranchClass
+  add Branch Delphes/allParticles Particle GenParticle
+  add Branch ElectronMomentumSmearing/electrons Electron Electron
+}
Index: classes/DelphesLongFormula.cc
===================================================================
--- classes/DelphesLongFormula.cc	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
+++ classes/DelphesLongFormula.cc	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -0,0 +1,127 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+
+#include "classes/DelphesLongFormula.h"
+
+#include "TString.h"
+
+#include <stdexcept>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+DelphesLongFormula::DelphesLongFormula() :
+  TFormula()
+{
+}
+
+//------------------------------------------------------------------------------
+
+DelphesLongFormula::DelphesLongFormula(const char *name, const char *expression) :
+  TFormula()
+{
+}
+
+//------------------------------------------------------------------------------
+
+DelphesLongFormula::~DelphesLongFormula()
+{
+}
+
+//------------------------------------------------------------------------------
+
+Int_t DelphesLongFormula::Compile(const char *expression)
+{
+  TString buffer;
+  const char *it;
+  for(it = expression; *it; ++it)
+  {
+    if(*it == ' ' || *it == '\t' || *it == '\r' || *it == '\n' || *it == '\\' ) continue;
+    buffer.Append(*it);
+  }
+
+  buffer.ReplaceAll("pt", "[pt]");
+  buffer.ReplaceAll("eta", "[eta]");
+  buffer.ReplaceAll("phi", "[phi]");
+  buffer.ReplaceAll("energy", "[energy]");
+  buffer.ReplaceAll("d0", "[d0]");
+  buffer.ReplaceAll("dz", "[dz]");
+  buffer.ReplaceAll("ctgTheta", "[ctgTheta]");
+
+  #if ROOT_VERSION_CODE < ROOT_VERSION(6,0,0)
+    TFormula::SetMaxima(100000,1000,1000000);
+  #endif
+  
+  if(TFormula::Compile(buffer) != 0)
+  {
+    throw runtime_error("Invalid Long Formula.");
+  }
+
+  return 0;
+}
+
+//------------------------------------------------------------------------------
+
+Double_t DelphesLongFormula::Eval(Double_t pt, 
+                                  Double_t eta, 
+                                  Double_t phi, 
+                                  Double_t energy,
+                                  Double_t d0,
+                                  Double_t dz,
+                                  Double_t ctgTheta
+                                 )
+{
+
+  TVarNameMap fVarNameMap;
+  TVarValMap fVarValMap;
+
+  fVarNameMap[this->GetParNumber("pt")]= "pt";
+  fVarNameMap[this->GetParNumber("eta")]= "eta";
+  fVarNameMap[this->GetParNumber("phi")]= "phi";
+  fVarNameMap[this->GetParNumber("energy")]= "energy";
+  fVarNameMap[this->GetParNumber("d0")]= "d0";
+  fVarNameMap[this->GetParNumber("dz")]= "dz";
+  fVarNameMap[this->GetParNumber("ctgTheta")]= "ctgTheta";
+
+  fVarValMap["pt"]= pt;      
+  fVarValMap["eta"]= eta;
+  fVarValMap["phi"]= phi;
+  fVarValMap["energy"]= energy;
+  fVarValMap["d0"]= d0;
+  fVarValMap["dz"]= dz;
+  fVarValMap["ctgTheta"]= ctgTheta;
+
+  Double_t vals[7];
+
+  Int_t j = 0;
+  for (Int_t i=0; i != 7; i++)
+  {
+     if ( fVarNameMap.find(i) != fVarNameMap.end() ) 
+     {
+        TString var_name = fVarNameMap[i];
+        vals[i] = fVarValMap[var_name];
+     }
+     else
+        vals[i] = 0.;
+  }   
+  return EvalPar(nullptr, vals);
+}
+
+//------------------------------------------------------------------------------
Index: classes/DelphesLongFormula.h
===================================================================
--- classes/DelphesLongFormula.h	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
+++ classes/DelphesLongFormula.h	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -0,0 +1,50 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef DelphesLongFormula_h
+#define DelphesLongFormula_h
+
+#include "TFormula.h"
+
+class DelphesLongFormula: public TFormula
+{
+public:
+
+  DelphesLongFormula();
+  DelphesLongFormula(const char *name, const char *expression);
+
+  ~DelphesLongFormula();
+
+  Int_t Compile(const char *expression);
+
+  Double_t Eval(Double_t pt, 
+                Double_t eta = 0, 
+                Double_t phi = 0, 
+                Double_t energy = 0,
+                Double_t d0 = 0,
+                Double_t dz = 0,
+                Double_t ctgTheta = 0
+                );
+
+  typedef std::map<Int_t,TString> TVarNameMap; //!
+  typedef std::map<TString, Double_t> TVarValMap; //!
+
+  
+};
+
+#endif /* DelphesLongFormula_h */
Index: modules/ModulesLinkDef.h
===================================================================
--- modules/ModulesLinkDef.h	(revision adde560017f6470fb7d5102af8fda3354682d4f4)
+++ modules/ModulesLinkDef.h	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -32,4 +32,5 @@
 #include "modules/ParticlePropagator.h"
 #include "modules/Efficiency.h"
+#include "modules/TrackEfficiency.h"
 #include "modules/IdentificationMap.h"
 #include "modules/EnergySmearing.h"
@@ -85,4 +86,5 @@
 #pragma link C++ class ParticlePropagator+;
 #pragma link C++ class Efficiency+;
+#pragma link C++ class TrackEfficiency+;
 #pragma link C++ class IdentificationMap+;
 #pragma link C++ class EnergySmearing+;
Index: modules/TrackEfficiency.cc
===================================================================
--- modules/TrackEfficiency.cc	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
+++ modules/TrackEfficiency.cc	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -0,0 +1,119 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+
+/** \class TrackEfficiency
+ *
+ *  Selects candidates from the InputArray according to the Efficiency formula.
+ *
+ *  \author M. Selvaggi - CERN
+ *
+ */
+
+#include "modules/TrackEfficiency.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesLongFormula.h"
+
+#include "ExRootAnalysis/ExRootResult.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootClassifier.h"
+
+#include "TMath.h"
+#include "TString.h"
+#include "TFormula.h"
+#include "TRandom3.h"
+#include "TObjArray.h"
+#include "TDatabasePDG.h"
+#include "TLorentzVector.h"
+
+#include <algorithm> 
+#include <stdexcept>
+#include <iostream>
+#include <sstream>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+TrackEfficiency::TrackEfficiency() :
+  fFormula(0), fItInputArray(0)
+{
+  fFormula = new DelphesLongFormula;
+}
+
+//------------------------------------------------------------------------------
+
+TrackEfficiency::~TrackEfficiency()
+{
+  if(fFormula) delete fFormula;
+}
+
+//------------------------------------------------------------------------------
+
+void TrackEfficiency::Init()
+{
+  // read TrackEfficiency formula
+
+  fFormula->Compile(GetString("EfficiencyFormula", "1.0"));
+
+  // import input array
+  fInputArray = ImportArray(GetString("InputArray", "ParticlePropagator/stableParticles"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array
+
+  fOutputArray = ExportArray(GetString("OutputArray", "stableParticles"));
+}
+
+//------------------------------------------------------------------------------
+
+void TrackEfficiency::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void TrackEfficiency::Process()
+{ 
+  Candidate *candidate;
+  Double_t pt, eta, phi, e, d0, dz, ctgTheta;
+
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate*>(fItInputArray->Next())))
+  {
+    const TLorentzVector &candidatePosition = candidate->Position;
+    const TLorentzVector &candidateMomentum = candidate->Momentum;
+    eta = candidatePosition.Eta();
+    phi = candidatePosition.Phi();
+    pt = candidateMomentum.Pt();
+    e = candidateMomentum.E();
+    d0 = candidate->D0;
+    dz = candidate->DZ;
+    ctgTheta = candidate->CtgTheta;
+
+    // apply an efficency formula
+    if(gRandom->Uniform() > fFormula->Eval(pt, eta, phi, e, d0, dz, ctgTheta)) continue;
+    
+    fOutputArray->Add(candidate);
+  }
+}
+
+//------------------------------------------------------------------------------
Index: modules/TrackEfficiency.h
===================================================================
--- modules/TrackEfficiency.h	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
+++ modules/TrackEfficiency.h	(revision c74995760bbccf4bbea6fdeb2335cb5d20c62489)
@@ -0,0 +1,60 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef TrackEfficiency_h
+#define TrackEfficiency_h
+
+/** \class TrackEfficiency
+ *
+ *  Selects candidates from the InputArray according to the Efficiency formula.
+ *
+ *  \author M. Selvaggi - CERN
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+class TIterator;
+class TObjArray;
+class DelphesLongFormula;
+
+class TrackEfficiency: public DelphesModule
+{
+public:
+
+  TrackEfficiency();
+  ~TrackEfficiency();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  DelphesLongFormula *fFormula; //!
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(TrackEfficiency, 1)
+};
+
+#endif
